package edu.chl.basixFX.control;

import com.google.common.eventbus.Subscribe;
import edu.chl.basixFX.events.MessageChangeEvt;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Label;


import static edu.chl.basixFX.Main.*;
import static java.lang.System.out;

/*
   Control part of application
 */
public class MainCtrl {

    @FXML
    private Label msg;

    // Incoming from GUI to model, using standard FX events
    public void buttonAction(ActionEvent actionEvent) {
        //out.println("I was clicked");
        MODEL.setMsg("I was clicked");
    }

    // Outgoing from model to GUI, using Google Guava event bus
    @Subscribe
    public void onEvent(MessageChangeEvt evt) {
        //out.println(evt.getMsg());
        msg.setText(evt.getMsg());
    }

    public MainCtrl() {
        BUS.register(this);
    }
}
