package edu.chl.hajo.monopoly.core;

import edu.chl.hajo.monopoly.event.Event;
import edu.chl.hajo.monopoly.event.EventBus;

import java.util.Random;

/**
 Monopoly specific pair of dices

 @author hajo
 */
public class Dices {

    private static final Random rand = new Random();
    private int first;    // Values for dices
    private int second;
    protected int doubleSixCount = 0;

    public void roll() {
        setFirst(rand.nextInt(6) + 1);
        setSecond(rand.nextInt(6) + 1);
        if (first == second && first == 6) {
            doubleSixCount++;
        }
    }

    public int getTotal() {
        return first + second;
    }

    public void reset() {
        doubleSixCount = 0;
        setFirst(0);
        setSecond(0);
    }

    public boolean isSpeeding() {
        return doubleSixCount >= 3;
    }
    
    // ---- Event Setters -----------------

    private void setFirst(int first) {
        this.first = first;
        EventBus.BUS.publish(new Event(Event.Tag.DICE_FST, first));
    }

    private void setSecond(int second) {
        this.second = second;
        EventBus.BUS.publish(new Event(Event.Tag.DICE_SEC, second));
    }

}
