package xmlrpc;

import java.io.IOException;

import org.junit.Assert;
import org.junit.Test;

/**
 * MUST comment out calls AND references to WordFeudServer and WordFeudClient in
 * the adapter classes
 * 
 * @author hajo
 * 
 */

public class TestXMLRPC {

    // Hard coded for development (single client)
    public static final String CLIENT_HANDLER = "client";
    public static final String CLIENT_PORT = "8888";
    public static final String CLIENT_URI = "http://127.0.0.1:" + CLIENT_PORT
            + "/" + CLIENT_HANDLER;

    public static final String SERVER_HANDLER = "server";
    public static final String SERVER_PORT = "9999";
    public static final String SERVER_URI = "http://127.0.0.1:" + SERVER_PORT
            + "/" + SERVER_HANDLER;

    @Test
    public void testServer() throws IOException {
        // Done on server side
        Receiver r = new Receiver(SERVER_HANDLER, SERVER_PORT,
                ServerAdapter.class);
        r.start();

        // Done on client side
        ServerProxy sp = new ServerProxy(SERVER_URI);
        String s = "Pelle";
        int i = 999;
        // Client call server
        sp.doIt(s, i); // Check out console

        // Server side
        r.stop();

        Assert.assertTrue(true); // Silly but this is special
    }

    @Test
    public void testClient() throws IOException {
        // On client side
        Receiver r = new Receiver(CLIENT_HANDLER, CLIENT_PORT,
                ClientAdapter.class);
        r.start();

        // On server side
        ClientProxy cp = new ClientProxy(CLIENT_URI);
        String s = "Pelle";
        int i = 999;
        // Server call client
        cp.doIt(s, i); // Check out console

        // Server side
        r.stop();

        Assert.assertTrue(true); // Silly but this is special
    }

}
