package edu.chl.hajo.td;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.Game;
import com.badlogic.gdx.Gdx;
import edu.chl.hajo.td.core.TDFactory;
import edu.chl.hajo.td.core.TowerDefence;
import edu.chl.hajo.td.screen.MainScreen;
import edu.chl.hajo.td.screen.io.Input;

/*
 Topleve libGDX class.
 This build the libGDX parts of the application, kind of
 factory
 */
public class TD extends Game {

    Texture texture;
    SpriteBatch batch;
    float elapsed;

    @Override
    public void create() {
        TowerDefence td = TDFactory.getTowerDefence();
        setScreen(new MainScreen(td));
        Gdx.input.setInputProcessor(new Input(td));
    }

    @Override
    public void resize(int width, int height) {
    }

    @Override
    public void render() {
        elapsed += Gdx.graphics.getDeltaTime();
        getScreen().render(elapsed);
    }

    @Override
    public void pause() {
    }

    @Override
    public void resume() {
    }

    @Override
    public void dispose() {
    }
}
