package chl.hajo.gdxdemo.core;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**

 @author hajo
 */
public class Rain {

    private final static Random rand = new Random();
    private final List<RainDrop> drops = new ArrayList();
    private final int maxDrops;
    private final int dropSize;   // Assume square
    private final int maxWidth;
    private final int maxHeight;
    

    public Rain(int maxWidth, int maxHeight, int maxDrops, int dropSize) {
        this.maxWidth = maxWidth;
        this.maxHeight = maxHeight;
        this.maxDrops = maxDrops;
        this.dropSize = dropSize;
    }

    public void spawnRaindrop() {
        if (drops.size() < maxDrops) {
            float x = rand.nextFloat() * (maxWidth - dropSize);   // TODO hard coded
            if( x < 0 ){
                x = 0;
            }
            RainDrop drop = new RainDrop(x, maxHeight, dropSize, dropSize );
            drops.add(drop);
            //out.println(drop + " n = " + drops.size());
        }
    }
    
    public void removeDrop( RainDrop drop ){
        drops.remove(drop);
    }

    public List<RainDrop> getRainDrops() {
        clean();
        return drops;
    }

    public int getMaxDrops() {
        return maxDrops;
    }

    private void clean() {
        for (int i = 0; i < drops.size(); i++) {
            RainDrop d = drops.get(i);
            if (d.getY() + d.getHeight() < 0 ) {
                drops.remove(i);
            }
        }
    }

}
